import * as React from 'react';
import {
    Table,
    TableBody,
    TableHeader,
    TableHeaderColumn,
    TableFooter,
    TableRow,
    TableRowColumn,
} from 'material-ui/Table';
import { Link, Route, Redirect } from 'react-router-dom';
import Divider from 'material-ui/Divider';
import { TargetSelector } from '../config/TargetSelector';
import FloatingActionButton from 'material-ui/FloatingActionButton';
import ContentAdd from 'material-ui/svg-icons/content/add';
import Dialog from 'material-ui/Dialog';
import FlatButton from 'material-ui/FlatButton';
import { Tabs, Tab } from 'material-ui/Tabs';
import TextField from 'material-ui/TextField';
import SelectField from 'material-ui/SelectField';
import MenuItem from 'material-ui/MenuItem';


const styles = {
    headline: {
        fontSize: 24,
        paddingTop: 16,
        marginBottom: 12,
        fontWeight: 400,
    },
}

export class AgentDetail extends React.Component<any, any> {
    constructor(props: any, context: any) {
        super(props, context)
        this.state = {
            targetAddOpen: false,
            targetAddType: 'host',
            hostToAdd : '',
            appToAdd: 1,
            addType : 'host'
        }

    };

    handleAddTarget = () => {
        this.setState({
            targetAddOpen: true
        })
    }
    handleAddTargetPopupCancle = () => {
        this.setState({ targetAddOpen: false });
    };

    handleRowSelected = (selectedRows: number[] | string) => {
        console.log(selectedRows);
    }

    handleTargetTypeChange = (value: any) => {
        this.setState({
            addType: value,
        });
    };

    handleAddTargetSubmit = (event: any) => {
       if (this.state.addType == "host") {
           alert(this.state.hostToAdd);
       }else if (this.state.addType == "application") {
           alert(this.state.appToAdd);
       }
       this.setState({targetAddOpen: false})
    };

    handleIPChange = (event: any) => {
        this.setState({
            hostToAdd : event.target.value
        })
    };

    handleApplicationChange = (event:any, index:any, value:any) => {
        this.setState({
            appToAdd : value
        })
    };

    render() {

        const actions = [
            <FlatButton
                label="Cancel"
                primary={true}
                onTouchTap={this.handleAddTargetPopupCancle}
            />,
            <FlatButton
                label="Submit"
                primary={true}
                onTouchTap={this.handleAddTargetSubmit}
            />,
        ];

        return (

            <div>
                <div style={{ height: 100 }}>
                    prove description area
                    </div>
                <Divider />

                <div style={{ padding: 10, float: 'right' }}>
                    <FloatingActionButton onClick={this.handleAddTarget}>
                        <ContentAdd />
                    </FloatingActionButton>
                </div>

                <div style={{ height: 300 }}>
                    discovery result + target area
                </div>

                <Dialog
                    title="Add Target to monitor"
                    actions={actions}
                    modal={true}
                    open={this.state.targetAddOpen}>

                    <Tabs
                        value={this.state.value}
                        onChange={this.handleTargetTypeChange}
                    >
                        <Tab label="Host" value="host">
                            <div style={{padding:20}}>
                                <TextField onChange={this.handleIPChange} 
                                    hintText="IP Address"
                                /><br />
                            </div>
                        </Tab>
                        <Tab label="Application" value="application">
                            <div style={{padding:20}}>
                                <SelectField
                                    value={this.state.appToAdd}
                                    onChange={this.handleApplicationChange}
                                >
                                    <MenuItem value={1} primaryText="MySQL" />
                                    <MenuItem value={2} primaryText="Redis" />
                                </SelectField>
                            </div>
                        </Tab>
                    </Tabs>

                </Dialog>>
            </div>

        );
    }


}