import * as React from 'react';
import {
    Table,
    TableBody,
    TableHeader,
    TableHeaderColumn,
    TableFooter,
    TableRow,
    TableRowColumn,
} from 'material-ui/Table';
import { Link, Route, Redirect } from 'react-router-dom';
import { OFRest } from '../../components/Rest';

const styles = {
    propContainer: {
        width: 200,
        overflow: 'hidden',
        margin: '20px auto 0',
    },
    propToggleHeader: {
        margin: '20px auto 10px',
    },
};

const tableData = [
    {
        agentId: '111',
        desc: 'Agent 1',
        status: 'Wait For Auth',
    },
    {
        agentId: 'wqekoekeeeeerw',
        desc: 'Agent 2',
        status: 'Wait For Auth',
    },
    {
        agentId: 'wqekoekeeeeerw',
        desc: 'Agent 3',
        status: 'Wait For Auth',
    },
    {
        agentId: 'wqekoekeeeeerw',
        desc: 'Agent 4',
        status: 'Wait For Auth',
    },
    {
        agentId: 'wqekoekeeeeerw',
        desc: 'Agent 5',
        status: 'Wait For Auth',
    },
    {
        agentId: 'wqekoekeeeeerw',
        desc: 'Agent 6',
        status: 'Wait For Auth',
    },
    {
        agentId: 'wqekoekeeeeerw',
        desc: 'Agent 7',
        status: 'Wait For Auth',
    },
];

export class Agents extends React.Component<any, any> {
    constructor(props: any, context: any) {
        super(props, context)
        this.state = {
            agents: []
        };
        this.getAgents();
    };

    getAgents = () => {
        let output: string;
        let obj: any; //new object declaration
        obj = {
            "phone": this.state.phone
        };

        let os: OFRest = new OFRest("Agent", "Regist", obj);

        os.Call().then(function (res) {
            return res.json();
        }).then(function (json) {
            console.log(json);
        }).catch(function (err) {
            console.log(err);
        });
    }


    handleRowSelected = (selectedRows: number[] | string) => {
        this.props.history.push('/agent/agentDetail');
    }

    render() {

        return (

            <div>
                <Table
                    selectable={true}
                    multiSelectable={false}
                    onRowSelection={this.handleRowSelected}
                >
                    <TableHeader
                        adjustForCheckbox={false}
                        enableSelectAll={false}
                        displaySelectAll={false}>
                        <TableRow>
                            <TableHeaderColumn tooltip="The Agent Id">Agent Id</TableHeaderColumn>
                            <TableHeaderColumn tooltip="The Description">Description</TableHeaderColumn>
                            <TableHeaderColumn tooltip="The Status">Status</TableHeaderColumn>
                        </TableRow>
                    </TableHeader>
                    <TableBody
                        displayRowCheckbox={false}
                    >
                        {tableData.map((row: any, index: number) => (
                            <TableRow key={index} >
                                <TableRowColumn>{row.agentId}</TableRowColumn>
                                <TableRowColumn>{row.desc}</TableRowColumn>
                                <TableRowColumn>{row.status}</TableRowColumn>
                            </TableRow>
                        ))};

                        </TableBody>
                </Table>
            </div>

        );
    }


}