import * as React from 'react';


import {
    Table,
    TableBody,
    TableFooter,
    TableHeader,
    TableHeaderColumn,
    TableRow,
    TableRowColumn,
} from 'material-ui/Table';
import IconMenu from 'material-ui/IconMenu';


const tableData = [
    {
        id: 0,
        name: 'CPU.USAGE',
        desc: 'desc....',
    },
    {
        id: 1,
        name: 'CPU.FREE',
        desc: 'desc....',
    },
    {
        id: 2,
        name: 'CPU.IDLE',
        desc: 'desc....',
    },
];


export class ItemSelector extends React.Component<any, any> {
    constructor(props: any, context: any) {
        super(props, context)
        this.state = {
            selected: [],
        };
    }


    isSelected = (index: any) => {
        return this.state.selected.indexOf(index) !== -1;
    };

    handleRowSelection = (selectedRows: any) => {
        this.setState({
            selected: selectedRows,
        });
        console.log(selectedRows);
    };

    render() {
        return (
            <div>
                <Table onRowSelection={this.handleRowSelection}
                    selectable={true}
                    multiSelectable={true}
                >
                    <TableHeader >
                        <TableRow>
                            <TableHeaderColumn colSpan={3}>CPU</TableHeaderColumn>
                        </TableRow>
                    </TableHeader>

                    <TableBody
                        deselectOnClickaway={false}
                    >
                        {tableData.map((row, index) => (
                            <TableRow key={index} selected={this.isSelected(index)} >
                                <TableRowColumn style={{ display: 'none' }}>{row.id}</TableRowColumn>
                                <TableRowColumn>{row.name}</TableRowColumn>
                                <TableRowColumn>{row.desc}</TableRowColumn>
                            </TableRow>
                        ))}
                    </TableBody>

                </Table>
            </div>
        );
    }
}