import * as React from 'react';

import { List, ListItem, makeSelectable } from 'material-ui/List';
import Subheader from 'material-ui/Subheader';
import Paper from 'material-ui/Paper';

const styles = {
    test: {
        display: 'inline-block',
        float: 'left',
        width: '50%',
        height: 550,
    },
}

let SelectableList = makeSelectable(List);

function wrapState(ComposedComponent: any, par: any) {
    return class SelectableList extends React.Component<any, any> {

        componentWillMount() {
            this.setState({
                selectedIndex: -1,
            });
        }

        handleRequestChange = (event: any, index: any) => {
            this.setState({
                selectedIndex: index,
            });
            par.handleSelect(index);
        };

        render() {
            return (
                <ComposedComponent
                    value={this.state.selectedIndex}
                    onChange={this.handleRequestChange}
                >
                    {this.props.children}
                </ComposedComponent>
            );
        }
    };
}



export class TargetSelector extends React.Component<any, any> {
    constructor(props: any, context: any) {
        super(props, context)
        SelectableList = wrapState(SelectableList, this);

    }

    handleSelect(idx: any) {
        this.props.onChange(idx);
    }

    render() {
        return (
            <div>
                <Paper style={styles.test}>
                    <SelectableList>
                        <Subheader>Select a target to monitor</Subheader>
                        <ListItem
                            value={1}
                            primaryText="192.168.1.0"
                            secondaryText={'Zone'}
                            initiallyOpen={true}
                            nestedItems={[
                                <ListItem
                                    value={2}
                                    primaryText="192.168.1.11"
                                    secondaryText={'Host'}
                                    initiallyOpen={true}
                                    nestedItems={[
                                        <ListItem
                                            value={3}
                                            primaryText="Redis"
                                            secondaryText="Port 5432" />,
                                        <ListItem
                                            value={4}
                                            primaryText="FTP"
                                            secondaryText="Port 5432" />,
                                    ]}
                                />,
                                <ListItem
                                    value={5}
                                    primaryText="192.168.1.12"
                                    secondaryText={'Host'}
                                    initiallyOpen={true}
                                    nestedItems={[
                                        <ListItem
                                            value={6}
                                            primaryText="MySQL"
                                            secondaryText="Port 5432" />,
                                        <ListItem
                                            value={7}
                                            primaryText="SSH"
                                            secondaryText="Port 5432" />,
                                    ]}
                                />,
                            ]}
                        />
                    </SelectableList>
                </Paper>
                <Paper style={styles.test}>
                    Target description...
                    </Paper>
            </div>
        );
    }
}
