import * as React from 'react';

import { List, ListItem, makeSelectable } from 'material-ui/List';
import Subheader from 'material-ui/Subheader';
import Paper from 'material-ui/Paper';

import { OFRest } from '../../components/Rest';
import * as Utils from '../../components/Utils';

const styles = {
  test: {
    display: 'inline-block',
    float: 'left',
    width: '50%',
    height: 550,
  },
  container: {
    width: '80%',

  }
}

let SelectableList = makeSelectable(List);

function wrapState(ComposedComponent: any, par: any) {
  return class SelectableList extends React.Component<any, any> {

    componentWillMount() {
      this.setState({
        selectedIndex: -1,
      });
    }

    handleRequestChange = (event: any, index: any) => {
      this.setState({
        selectedIndex: index,
      });
      par.handleSelect(index);
    };

    render() {
      return (
        <ComposedComponent
          value={this.state.selectedIndex}
          onChange={this.handleRequestChange}
        >
          {this.props.children}
        </ComposedComponent>
      );
    }
  };
}

var testRes = "[{\"id\":1,\"ip\":3232235882,\"port\":5432,\"targetType\":\"DATABASE\",\"vendorName\":\"PostgreSQL 9.5.0\",\"kinds\":\"PostgreSQL\",\"version\":\"9.5.0\",\"createDate\":1496631864025,\"member\":{\"id\":1,\"email\":\"insanity33@loafle.com\",\"pwSalt\":\"salktttt\",\"digest\":\"bbbbbbbbb\",\"name\":\"insanity3\",\"company\":\"loafle\",\"phone\":\"000-000-0000\",\"authorizedDate\":null}},{\"id\":2,\"ip\":3232235882,\"port\":5432,\"targetType\":\"DATABASE\",\"vendorName\":\"PostgreSQL 9.5.0\",\"kinds\":\"PostgreSQL\",\"version\":\"9.5.0\",\"createDate\":1496635285090,\"member\":{\"id\":1,\"email\":\"insanity33@loafle.com\",\"pwSalt\":\"salktttt\",\"digest\":\"bbbbbbbbb\",\"name\":\"insanity3\",\"company\":\"loafle\",\"phone\":\"000-000-0000\",\"authorizedDate\":null}},{\"id\":3,\"ip\":3232235882,\"port\":5432,\"targetType\":\"DATABASE\",\"vendorName\":\"PostgreSQL 9.5.0\",\"kinds\":\"PostgreSQL\",\"version\":\"9.5.0\",\"createDate\":-62135596800000,\"member\":{\"id\":1,\"email\":\"\",\"pwSalt\":\"\",\"digest\":\"\",\"name\":\"\",\"company\":\"\",\"phone\":\"\",\"authorizedDate\":0}}]";

var RES = JSON.parse(testRes);

export class TargetList extends React.Component<any, any> {
  constructor(props: any, context: any) {
    super(props, context)
    SelectableList = wrapState(SelectableList, this);

    this.componentWillMount = this.componentWillMount.bind(this)

  }

  componentWillMount() {
    this.getTargetList();
  }

  getTargetList() {



    // let os: OFRest = new OFRest("Member", "Regist", obj);

    // os.Call().then(function (res) {
    //   return res.json();
    // }).then(function (json) {
    //   console.log(json);
    // }).catch(function (err) {
    //   console.log(err);
    // });

    
  }

  handleSelect(idx: any) {
    this.props.onChange(idx);
  }

  render() {
    let num :number;
    num = 1;
    return (
      <div style={styles.container}>

        <SelectableList>
          <Subheader>Select a target to monitor</Subheader>
          <ListItem
            value={num++}
            primaryText="192.168.1.0"
            secondaryText={'Zone'}
            initiallyOpen={true}
            nestedItems={[
              

              RES.map(function (item: any, index: number) {
                
                let port :string;
                port = "Port : "
                
                
                return (
                  <ListItem
                    value={num++}
                    primaryText={Utils.int2ip(item.ip)}
                    secondaryText={'Host'}
                    initiallyOpen={true}
                    nestedItems={[
                      <ListItem
                        value={num++}
                        primaryText={item.vendorName}
                        secondaryText={item.port} />,
                     
                    ]}
                  />
                )
              })
            ]}
          />
        </SelectableList>


      </div>
    );
  }
}
